package com.planet.rmu.rfid;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.text.TextUtils;

import com.common.app.base.BaseApplication;
import com.common.app.global.GlobalBroadcastActionName;
import com.common.framework.util.AppUtil;
import com.common.framework.util.AspLog;
import com.tencent.bugly.Bugly;
import com.tencent.bugly.BuglyStrategy;
import com.tencent.bugly.beta.Beta;


/**
 * Created by guqingbo on 2015/9/22.
 */
public class MyApplication extends BaseApplication {
    private static final String TAG = "MyApplication";
    private static MyApplication sInstance;


    public static synchronized MyApplication getInstance() {
        return sInstance;
    }
    
    @Override
    protected void initParam() {
        sInstance = this;
        VERSION_NAME = BuildConfig.VERSION_NAME;
        CHANNEL_VALUE = BuildConfig.FLAVOR;

        initBugly();


        if (AppUtil.isMainProcess(this)) {
            registerBroadcastReceiver();
        }
    }

    private void initBugly() {
//        Beta.autoInit = true;
////        String buglyAppId = AppUtil.getMetaDataValue(getApplicationContext(), "BUGLY_APP_ID");
//        String buglyAppId = BuildConfig.BUGLY_APP_ID;
//        String channel = getApplicationChannel();
//        if (TextUtils.isEmpty(channel)) {
//            channel = "unknow";
//        }
//        BuglyStrategy strategy = new BuglyStrategy();
//        /**
//         * 设置app渠道号.
//         */
//        strategy.setAppChannel(channel);
//        Bugly.init(getApplicationContext(), buglyAppId, true, strategy);
    }

    protected void registerBroadcastReceiver() {
        AspLog.d(TAG, "registerBroadcastReceiver........................................." + this);
        IntentFilter filter = new IntentFilter();
        filter.addAction(GlobalBroadcastActionName.USER_SESSION_INVALID);
        filter.addAction(GlobalBroadcastActionName.USER_LOGIN_MULTI_TERMINAL);

        mLocalBroadcastManager.registerReceiver(broadcastReceiver, filter);
    }

    protected void unRegisterBroadcastReceiver() {
        AspLog.d(TAG, "unRegisterBroadcastReceiver........................................." + this);
        mLocalBroadcastManager.unregisterReceiver(broadcastReceiver);
    }

    protected BroadcastReceiver broadcastReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            AspLog.d(TAG, "onReceive........................................." + intent.getAction() + " : " + this);
//            if (intent.getAction().equals(GlobalBroadcastActionName.USER_SESSION_INVALID)) {
//
////                ToastUtil.Toast(context, context.getResources().getString(R.string.session_invalid));
////                Intent intentLogin = new Intent(context, LoginActivity.class);
////                intentLogin.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
////                context.startActivity(intentLogin);
//////                context.overridePendingTransition(R.anim.in_from_right, R.anim.out_to_left);
////                ManageActivity.getInstance().exitAllActivity();
////                UserUtil.logoutClearCache(getApplicationContext());
//            }
//            if (intent.getAction().equals(GlobalBroadcastActionName.USER_LOGIN_MULTI_TERMINAL)) {
////                ToastUtil.toast(context, R.string.login_multi_terminal);
//                Intent intentLogin = new Intent(context, RegisterActivity.class);
//                intentLogin.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//                context.startActivity(intentLogin);
//
//                ManageActivity.getInstance().exitAllActivity();
//                UserUtil.logoutClearCache(getApplicationContext());
//            }
        }
    };
}




