package com.planet.rmu.rfid.ui;

import android.os.Bundle;
import android.widget.Toast;

import com.common.app.ui.util.ManageActivity;
import com.planet.rmu.rfid.R;
import com.planet.rmu.rfid.ui.base.BaseBottomMultiFragmentActivity;
import com.planet.rmu.rfid.ui.device.HomePageFragment;
import com.planet.rmu.rfid.ui.setting.SettingFragment;


public class MainActivity extends BaseBottomMultiFragmentActivity {
    private long mBackTime = -1;
    private static final long DIFF_DEFAULT_BACK_TIME = 2000;


    @Override
    protected int getTopbarViewId() {
        return 0;
    }


    @Override
    protected Class[] getFragmentArray() {
        Class fragmentArray[] = {HomePageFragment.class, SettingFragment.class};

        return fragmentArray;
    }

    @Override
    protected String[] getTextArray() {
        String textArray[] = {getResources().getString(R.string._homepage), getResources().getString(R.string._setting)};

        return textArray;
    }

    @Override
    protected int[] getIconArray() {
        int iconArray[] = {
                R.drawable.selector_bottom_tab_home, R.drawable.selector_bottom_tab_more};

        return iconArray;
    }

    @Override
    protected Bundle getBundle(int index) {
        return null;
    }


    @Override
    public void onBackPressed() {
        long nowTime = System.currentTimeMillis();
        long diff = nowTime - mBackTime;
        if (diff >= DIFF_DEFAULT_BACK_TIME) {
            mBackTime = nowTime;
            Toast.makeText(getApplicationContext(), R.string.exit_app, Toast.LENGTH_SHORT).show();
        } else {
            ManageActivity.getInstance().exitAllActivity();
            super.onBackPressed();
        }
    }


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

    }


    @Override
    protected void onDestroy() {


        super.onDestroy();

    }
}
