package com.planet.rmu.rfid.ui.adapter;

import android.content.Context;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.planet.rmu.rfid.MessageBean;
import com.planet.rmu.rfid.R;

import java.util.List;

/**
 * Created by hongfei02.chen on 2019-10-28.
 */
public class AdapterMessage extends ArrayAdapter<MessageBean> {
    private final   int mResourceId;
    List<MessageBean> mDataList ;
    public AdapterMessage(@NonNull Context context, int resource, List<MessageBean> dataList) {
        super(context, resource);
        mResourceId = resource;
        mDataList = dataList;
    }

    @NonNull
    @Override
    public View getView(int position, @Nullable View convertView, @NonNull ViewGroup parent) {

        MessageBean messageBean = getItem(position); // 获取当前项的Fruit实例
        View view = LayoutInflater.from(getContext()).inflate(mResourceId, null);//实例化一个对象

        TextView tvDeviceName = view.findViewById(R.id.tv_device_name);
        TextView tvId = view.findViewById(R.id.tv_id);
        TextView tvDatetime = view.findViewById(R.id.tv_datetime);
        tvDeviceName.setText(messageBean.deviceName);
        tvId.setText(messageBean.id);
        tvDatetime.setText(messageBean.datetime);

        return view;
    }
}
