package com.planet.rmu.rfid.ui.adapter;

import android.content.Context;
import android.databinding.ViewDataBinding;
import android.text.TextUtils;

import com.common.app.base.BaseViewHolder;
import com.common.app.databinding.AdapterSimpleListItemBinding;
import com.common.app.ui.adapter.RAdapterFilter;
import com.common.framework.util.AspLog;
import com.common.framework.util.CollectionUtil;
import com.planet.rmu.rfid.R;

import java.util.List;

/**
 * Created by apple on 17/2/19.
 */

public class RAdapterSimpleListItem extends RAdapterFilter<String> {


    public RAdapterSimpleListItem(Context context, List<String> dataList, String chosedString) {
        super(context, dataList);
        mLayoutId = R.layout.adapter_simple_list_item;
        mSelectedPosition = getSelectedPosition(dataList, chosedString);
    }

    @Override
    public String getFilterString(int position) {
        return mDataList.get(position);
    }

    @Override
    public void onBindViewHolder(BaseViewHolder baseViewHolder, int position) {
        super.onBindViewHolder(baseViewHolder, position);

        AdapterSimpleListItemBinding binding = (AdapterSimpleListItemBinding) baseViewHolder.getBinding();
        AspLog.e("jsonjson", "ttt:" + mDataList.get(position));
        binding.tvContent.setText(mDataList.get(position));
    }

    private int getSelectedPosition(List<String> dataList, String chosedString) {
        if (CollectionUtil.isEmpty(dataList) || TextUtils.isEmpty(chosedString)) {
            return -1;
        }
        for (int i = 0; i < dataList.size(); i++) {
            if (chosedString.equals(dataList.get(i))) {
                return i;
            }
        }
        return -1;
    }


}
