package com.planet.rmu.rfid.ui.base;

import android.os.Bundle;
import android.webkit.WebView;
import android.webkit.WebViewClient;

import com.common.app.base.BaseDataBindingActivity;
import com.common.app.ui.bar.ToolBarTop;
import com.planet.rmu.rfid.R;
import com.planet.rmu.rfid.databinding.ActivityBaseWebViewBinding;

/**
 * Created by alexgu on 2017/7/16.
 */

public class BaseWebViewActivity extends BaseDataBindingActivity<ActivityBaseWebViewBinding> {
    ToolBarTop toolBarTop;
    private String url;
    private String userId;
    private WebView webView;

    @Override
    protected int getContentViewId() {
        return R.layout.activity_base_web_view;
    }

    @Override
    protected int getTopbarViewId() {
        return R.layout.view_toolbar;
    }

    @Override
    protected void initParams(Bundle savedInstanceState) {
        url = getIntent().getStringExtra("url");
        userId = getIntent().getStringExtra("userId");
    }

    @Override
    protected void initView() {
        toolBarTop.setLeftBack(this);

        webView = getContentViewBinding().wvView;
        // 设置WebView能够执行javaScript脚本
        webView.getSettings().setJavaScriptEnabled(true);
        // 设置可以支持缩放
        webView.getSettings().setSupportZoom(true);
        // 设置出现缩放工具
        webView.getSettings().setBuiltInZoomControls(true);
        // 扩大比例的缩放
        webView.getSettings().setUseWideViewPort(true);
        // 自适应屏幕
        webView.getSettings().setLoadWithOverviewMode(true);
        webView.getSettings().setUseWideViewPort(true);
        webView.setWebViewClient(webViewClient);
    }

    @Override
    protected void loadData() {

    }

    WebViewClient webViewClient = new WebViewClient() {
        @Override
        public void onPageFinished(WebView view, String url) {
            super.onPageFinished(view, url);
        }
    };

    public void writeUserName(String userId, String username) {
        final String strJS = String
                .format("javascript:document.getElementById('%s').value='%s';",
                        userId, username);
        webView.post(new Runnable() {
            public void run() {
                webView.loadUrl(strJS);
            }
        });
    }
}
