package com.planet.rmu.rfid.ui.device;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.Toast;

import com.common.app.base.BaseDataBindingFragment;
import com.common.app.databinding.ViewToolbarBinding;
import com.common.app.ui.bar.ToolBarTop;
import com.common.framework.util.ToastUtil;
import com.planet.rmu.rfid.BluetoothChat;
import com.planet.rmu.rfid.BluetoothChatService;
import com.planet.rmu.rfid.Bluetooth_textActivity;
import com.planet.rmu.rfid.CHexConver;
import com.planet.rmu.rfid.R;
import com.planet.rmu.rfid.databinding.FragmentDeviceEntryBinding;
import com.planet.rmu.rfid.ui.activity.ConnectBlueToothActivity;

import java.io.UnsupportedEncodingException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Created by apple on 2017/11/18.
 */

public class HomePageFragment extends BaseDataBindingFragment<FragmentDeviceEntryBinding> implements View.OnClickListener {
    private ToolBarTop mToolbarTop;

    // Message types sent from the BluetoothChatService Handler
    public static final int MESSAGE_STATE_CHANGE = 1;
    public static final int MESSAGE_READ = 2; //
    public static final int MESSAGE_WRITE = 3;
    public static final int MESSAGE_DEVICE_NAME = 4;
    public static final int MESSAGE_TOAST = 5;

    private BluetoothChatService mChatService = null;


    List<String> mDataList = new ArrayList<>();

    String mConnectedDeviceName = "";

    String slk = "01";

    @Override
    protected int getContentViewId() {
        return R.layout.fragment_device_entry;
    }

    @Override
    protected int getTopbarViewId() {
        return R.layout.view_toolbar;
    }

    @Override
    protected void initParams(Bundle savedInstanceState) {
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
    }

    @Override
    protected void initView(View view) {
        mToolbarTop = ((ViewToolbarBinding) getTopbarViewBinding()).toolbarTop;
        mToolbarTop.hideLeft();
        mToolbarTop.setTitle("");

        getContentViewBinding().setClickListener(this);
    }

    @Override
    protected void loadData() {

    }

    private BluetoothAdapter mBluetoothAdapter = null;
    final int REQUEST_ENABLE_BT = 0;
    final int REQUEST_CONNECT_DEVICE = 1;

    @Override
    public void onClick(View v) {

        switch (v.getId()) {
            case R.id.cv_connect_bluetooth:
                Intent serverIntent = new Intent(getContext(), ConnectBlueToothActivity.class);
                startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
//                mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
//
//                // If the adapter is null, then Bluetooth is not supported
//                if (mBluetoothAdapter == null) {
//                    ToastUtil.toast("Bluetooth is not available");
//
//                    return;
//                }
//                if (!mBluetoothAdapter.isEnabled()) {
//                    Intent enableIntent = new Intent(
//                            BluetoothAdapter.ACTION_REQUEST_ENABLE);
//                    startActivityForResult(enableIntent, REQUEST_ENABLE_BT);
//                    // Otherwise, setup the chat session
//                }
                break;
            case R.id.cv_device_check:
                readRfid();
                break;
            case R.id.cv_inventory_read:
                writeRfid();
                break;
            case R.id.cv_fix_device:
                clearRfid();
                break;
        }
    }

    int i = 0;
    int izt = 0;
    String zzc;
    String sendMsg;

    String flag = "00";
    private void readRfid() {
        String scsk = "00";//meditTextcsk.getText().toString().trim();
        String sslk = "01";// meditTextslk.getText().toString().trim();
        if(scsk.length()!=2 | sslk.length()!=2 ){

            return;
        }
        String sml = "2000000000" + flag + scsk + sslk;
        String slen = Integer.toHexString(sml.length()/2 + 1);
        if (slen.length() == 1)
        {
            slen = "0" + slen;
        }
        sml = "AA" + slen + sml + "55";

        izt = 1;
        try {
            sendMessage(sml);
        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    private void writeRfid() {
        String scsk = "00";//meditTextcsk.getText().toString().trim();
        String sslk = "01";// meditTextslk.getText().toString().trim();
        String sdata = "0000";//meditTextwd.getText().toString().trim();
        if(scsk.length()!=2 | sslk.length()!=2 | sdata.length()!=4 ){
            ToastUtil.toast("Parameter error, please enter again!");
            return;
        }
        if(!sslk.equals("01")){
            ToastUtil.toast("Every time I write only a block!");
            return;
        }
        String sml = "2100000000" + flag + scsk + sslk + sdata;

        String slen = Integer.toHexString(sml.length()/2 + 1);
        if (slen.length() == 1)
        {
            slen = "0" + slen;
        }
        sml = "AA" + slen + sml + "55";

        izt = 2;
        try {
            sendMessage(sml);
        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    private void clearRfid() {
        Intent intentDeviceCheck = new Intent(mActivity, BluetoothChat.class);
        startActivity(intentDeviceCheck);

    }

    /**
     * Sends a message
     *
     * @param message
     *            A string of text to send.
     * @throws UnsupportedEncodingException
     */
    private void sendMessage(String message)
            throws UnsupportedEncodingException {
        if (mChatService.getState() != BluetoothChatService.STATE_CONNECTED) {
            ToastUtil.toast(R.string.not_connected);
            return;
        }

        if (message.length() > 0) {
            byte[] send = CHexConver.hexStr2Bytes(message.toUpperCase());
            mChatService.write(send);
            sendMsg = message;
        }
    }

    private void setupChat() {



        mChatService = new BluetoothChatService(getContext(), mHandler);


    }

    @Override
    public void onStart() {
        super.onStart();


        // If BT is not on, request that it be enabled.
        // setupChat() will then be called during onActivityResult
        if (!mBluetoothAdapter.isEnabled()) {
            Intent enableIntent = new Intent(
                    BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableIntent, REQUEST_ENABLE_BT);
            // Otherwise, setup the chat session
        } else {
            if (mChatService == null)
                setupChat();
        }
    }

    @Override
    public synchronized void onResume() {
        super.onResume();

        // Performing this check in onResume() covers the case in which BT was
        // not enabled during onStart(), so we were paused to enable it...
        // onResume() will be called when ACTION_REQUEST_ENABLE activity
        // returns.
        if (mChatService != null) {
            // Only if the state is STATE_NONE, do we know that we haven't
            // started already
            if (mChatService.getState() == BluetoothChatService.STATE_NONE) {
                // Start the Bluetooth chat services
                mChatService.start();
            }
        }
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch (requestCode) {
            case REQUEST_CONNECT_DEVICE:
                // When DeviceListActivity returns with a device to connect
                if (resultCode == Activity.RESULT_OK) {
                    // Get the device MAC address
                    String address = data.getExtras().getString(
                            ConnectBlueToothActivity.EXTRA_DEVICE_ADDRESS);
                    BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(address);
                    mChatService.connect(device);
                }
                break;
            case REQUEST_ENABLE_BT:
                if (resultCode == Activity.RESULT_OK) {
                    setupChat();
                } else {
                    ToastUtil.toast(R.string.bt_not_enabled_leaving);

                }
        }
    }

    private final Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case MESSAGE_STATE_CHANGE:

//                    switch (msg.arg1) {
//                        case BluetoothChatService.STATE_CONNECTED:
//                            mTitle.setText(R.string.title_connected_to);
//                            mTitle.append(mConnectedDeviceName);
//                            mConversationArrayAdapter.clear();
//                            break;
//                        case BluetoothChatService.STATE_CONNECTING:
//                            mTitle.setText(R.string.title_connecting);
//                            break;
//                        case BluetoothChatService.STATE_LISTEN:
//                        case BluetoothChatService.STATE_NONE:
//                            mTitle.setText(R.string.title_not_connected);
//                            break;
//                    }
                    break;
                case MESSAGE_WRITE:
                    //byte[] writeBuf = (byte[]) msg.obj;
                    // construct a string from the buffer
                    //String writeMessage = new String(writeBuf);
                    //mConversationArrayAdapter.add("Me:  " + sendMsg);
                    break;
                case MESSAGE_READ:
                    String s3 = String.valueOf(CHexConver.byte2HexStr(
                            (byte[]) msg.obj, msg.arg1));
                    String readMessage = (new StringBuilder(s3)).append(" ")
                            .toString();

                    //AA 11 10 00 34 00 E3 25 77 DD 8F F2 DC 7B 00 00 09 FD 55
                    zzc += readMessage;
                    System.out.println(zzc);
                    if (zzc.substring(0,2).equals("AA") && zzc.substring(zzc.length() - 3,
                            zzc.length() - 1).equals("55")) {
                        Date curDate   =   new   Date(System.currentTimeMillis());
                        SimpleDateFormat formatter   =   new   SimpleDateFormat   ("yyyy-MM-dd HH:mm:ss");
                        // Date   curDate   =   new   Date(System.currentTimeMillis());//��ȡ��ǰʱ��
                        String   str   =   formatter.format(curDate);
                        String s1 = "";
                        String sdata = "";
                        int len = 0;
                        int l = 0;
                        String sslk = slk;
                        while(zzc.length()>4){
                            len = (Integer. parseInt(zzc.substring(3,5),16) + 2)*3;
                            s1 = zzc.substring(6,8);
                            if(s1.equals("12") && len == 15){
                                mDataList.add(mConnectedDeviceName + ": Stop Scanning... 	" + str);
                            }
                            if((s1.equals("10") || s1.equals("11")) && len == 15){
                                mDataList.add(mConnectedDeviceName + ": Start Scanning... 	" + str);
                            }
                            if((s1.equals("10") || s1.equals("11")) && len > 15){
                                String sid = zzc.substring(18, len - 3);
                                mDataList.add(mConnectedDeviceName + ":" + sid +"	" + str);
                            }
                            if(s1.equals("20"))
                            {
                                if(zzc.subSequence(9, 11).equals("00"))
                                {
                                    mDataList.add(mConnectedDeviceName + ": Read data successfully... 	" + str);
                                    l = Integer. parseInt(sslk,16) * 6;
                                    sdata = zzc.substring(18 + l, len - 3);
                                    mDataList.add(mConnectedDeviceName + ":ID:" + sdata);
                                    sdata = zzc.substring(12, 12 + l);
                                    mDataList.add(mConnectedDeviceName + ":Datas:" + sdata);
                                }
                                else
                                {
                                    mDataList.add(mConnectedDeviceName + ": Failed to read data... 	" + str);
                                }
                            }
                            if(s1.equals("21"))
                            {
                                if(zzc.subSequence(9, 11).equals("00"))
                                {
                                    mDataList.add(mConnectedDeviceName + ": Write data successfully... 	" + str);

                                    sdata = zzc.substring(18, len - 3);
                                    mDataList.add(mConnectedDeviceName + ":ID:" + sdata);
                                }
                                else
                                {
                                    mDataList.add(mConnectedDeviceName + ": Failed to write data... 	" + str);
                                }
                            }
                            zzc = zzc.substring(len);
                        }
                        zzc = "";
                    }
                    i++;
                    break;
                case MESSAGE_DEVICE_NAME:
                    // save the connected device's name
//                    mConnectedDeviceName = msg.getData().getString(DEVICE_NAME);
//                    Toast.makeText(getApplicationContext(),
//                            "Connected to " + mConnectedDeviceName,
//                            Toast.LENGTH_SHORT).show();
                    break;
                case MESSAGE_TOAST:
//                    Toast.makeText(getApplicationContext(),
//                            msg.getData().getString(TOAST), Toast.LENGTH_SHORT)
//                            .show();
                    break;
            }
        }
    };
}
