package com.common.app.base;

import android.content.Context;
import android.databinding.DataBindingUtil;
import android.databinding.ViewDataBinding;
import android.support.annotation.LayoutRes;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import java.util.List;

/**
 * Created by apple on 17/3/26.
 */

public class BaseAdapter<D> extends RecyclerView.Adapter<BaseViewHolder> {

    protected LayoutInflater mInflater;
    protected Context mContext;
    protected List<D> mDataList;

    @LayoutRes
    protected int mLayoutId;
    protected int mBrId;// layout声明的variable id

    public BaseAdapter() {}

    public BaseAdapter(Context context, List<D> dataList, @LayoutRes int layoutId, int brId) {
        mContext = context;
        mDataList = dataList;
        mLayoutId = layoutId;
        mBrId = brId;

        mInflater = LayoutInflater.from(mContext);
    }

    @Override
    public BaseViewHolder onCreateViewHolder(ViewGroup viewGroup, int i) {
        ViewDataBinding binding = DataBindingUtil.inflate(mInflater, mLayoutId, viewGroup, false);
        BaseViewHolder viewHolder = new BaseViewHolder(binding.getRoot());
        viewHolder.setBinding(binding);

        return viewHolder;
    }

    @Override
    public void onBindViewHolder(BaseViewHolder baseViewHolder, int i) {
        baseViewHolder.getBinding().setVariable(mBrId, mDataList.get(i));
        baseViewHolder.getBinding().executePendingBindings();
    }

    @Override
    public int getItemCount() {
        return mDataList == null ? 0 : mDataList.size();
    }

}
