package com.common.app.base;

import android.support.v7.widget.RecyclerView;
import android.view.View;

import com.common.app.R;
import com.common.app.databinding.CommonRecyclerviewBinding;
import com.common.app.databinding.ViewToolbarBinding;
import com.common.app.ui.bar.ToolBarTop;

/**
 * Created by chenhongfei on 2017/4/26.
 */

public abstract class BaseBindingCommonRecyclerViewFragment<D, VDB extends CommonRecyclerviewBinding> extends BaseBindingRecyclerViewFragment<D, CommonRecyclerviewBinding> {

    protected ToolBarTop mToolBarTop;

    @Override
    protected int getTopbarViewId() {
        return R.layout.view_toolbar;
    }

    @Override
    protected int getContentViewId() {
        return R.layout.common_recyclerview;
    }

    @Override
    protected RecyclerView getRecyclerView() {
        return getContentViewBinding().recyclerView;
    }

    @Override
    protected void initView(View view) {
        super.initView(view);
        mToolBarTop = ((ViewToolbarBinding) getTopbarViewBinding()).toolbarTop;
        mToolBarTop.setLeftBack(mActivity);
        mToolBarTop.setTitle(mTitle);
        mToolBarTop.hideRight();
    }
}
