package com.common.app.base;

import android.content.Context;
import android.view.LayoutInflater;

import java.util.List;

/**
 * Created by chenhongfei on 2016/8/19.
 */
public abstract class BaseExpandableListAdapter<T> extends android.widget.BaseExpandableListAdapter {
    protected LayoutInflater mInflater;
    protected Context mContext;
    protected List<T> mDataList;

    public BaseExpandableListAdapter(Context context, List<T> dataList){
        mContext = context;
        mDataList = dataList;
        mInflater = LayoutInflater.from(mContext);
    }

    //仅为兼容以前的
    public BaseExpandableListAdapter(){

    }

    @Override
    public int getGroupCount() {
        return mDataList.size();
    }

    @Override
    public Object getGroup(int groupPosition) {
        return mDataList.get(groupPosition);
    }

    @Override
    public long getGroupId(int groupPosition) {
        return groupPosition;
    }

    @Override
    public long getChildId(int groupPosition, int childPosition) {
        return childPosition;
    }

    @Override
    public boolean hasStableIds() {
        return false;
    }

    @Override
    public boolean isChildSelectable(int groupPosition, int childPosition) {
        return true;
    }
}
