package com.common.app.base;

import android.app.Activity;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

/**
 * 此类没有进行umeng统计
 */
public abstract class BaseFragment extends Fragment {

    protected Activity mActivity;
    protected View mRootView;

    @Override
    public void onAttach(Activity activity) {
        super.onAttach(activity);
        this.mActivity = activity;
    }

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        mRootView = inflater.inflate(getContentViewId(),container,false);
        initParams();
        initView(mRootView);
        setViewInfo(mRootView);
        setData();
        return mRootView;
    }

    protected abstract int getContentViewId();

    protected abstract void initParams();

    protected abstract void initView(View rootView);

    protected abstract void setViewInfo(View rootView);

    protected abstract void setData();

    public void onBadLineView() {

    }



}
