package com.common.app.data.sharedpreferences;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;

import com.common.app.base.BaseApplication;
import com.common.app.global.SharedPrefsKey;

/**
 * 操作 other shared_preferences的类
 * <p/>
 * Created by chenhongfei on 2016/1/13.
 */
public class SharedPrefsOther {
    private static final String SHARED_PREFS_FILE = "other";
    private static SharedPrefsOther mInstance;
    private static SharedPreferences mSharedPrefs;

    public synchronized static SharedPrefsOther getInstance() {
        if (mInstance == null) {
            mInstance = new SharedPrefsOther(BaseApplication.getInstance());
        }

        return mInstance;
    }

    private SharedPrefsOther(Context context) {
        mSharedPrefs = context.getSharedPreferences(SHARED_PREFS_FILE, Activity.MODE_PRIVATE);
    }

    /**
     * 获取download id
     *
     * @return
     */
    public long getDownloadId() {
        if (mSharedPrefs != null) {
            return mSharedPrefs.getLong(SharedPrefsKey.KEY_DOWNLOAD_ID, 0);
        }
        return 0;
    }

    /**
     * save download id
     *
     * @param downloadId
     */
    public void saveDownloadId(long downloadId) {
        mSharedPrefs.edit().putLong(SharedPrefsKey.KEY_DOWNLOAD_ID, downloadId).apply();
    }

}
