package com.common.app.data.sharedpreferences;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.databinding.BaseObservable;
import android.text.TextUtils;

import com.common.app.base.BaseApplication;
import com.common.app.global.SharedPrefsKey;
import com.google.gson.Gson;


/**
 * Created by chenhongfei on 2016/2/26.
 */
public class SharedPrefsSetting  {
    private static final String TAG = "SharedPrefsSetting";

    private static final String SHARED_PREFS_FILE = "setting";
    private static SharedPrefsSetting mInstance;
    private static SharedPreferences mSharedPrefs;
    private static Context mContext;
    private static Gson mGson = new Gson();

    public synchronized static SharedPrefsSetting getInstance() {
        if (mInstance == null) {
            mInstance = new SharedPrefsSetting(BaseApplication.getInstance().getApplicationContext());
        }

        return mInstance;
    }

    public synchronized static SharedPrefsSetting getInstance(Context context) {
        return getInstance();
    }

    private SharedPrefsSetting(Context context) {
        mContext = context;
        mSharedPrefs = mContext.getSharedPreferences(SHARED_PREFS_FILE, Activity.MODE_PRIVATE);
    }

    /**
     * 清除数据
     */
    public void clearData() {


        SharedPreferences.Editor editor = mSharedPrefs.edit();
        editor.clear().commit();
        //保留用户名

    }


    public boolean getFileSyncState(String fileName) {
        if (mSharedPrefs != null && mContext != null) {
            return mSharedPrefs.getBoolean(fileName, true);
        }

        return false;
    }

    public boolean saveFileSyncState(String fileName, boolean b) {
        return mSharedPrefs.edit().putBoolean(fileName, b).commit();
    }




    public boolean saveDeviceReadFileSync(boolean b) {
        return mSharedPrefs.edit().putBoolean("deviceRead", b).commit();
    }

    public boolean getDeviceCheckFileSync() {
        if (mSharedPrefs != null && mContext != null) {
            return mSharedPrefs.getBoolean("deviceCheck", true);
        }

        return false;
    }

    public boolean saveDeviceCheckFileSync(boolean b) {
        return mSharedPrefs.edit().putBoolean("deviceCheck", b).commit();
    }

    public boolean getInventoryReadFileSync() {
        if (mSharedPrefs != null && mContext != null) {
            return mSharedPrefs.getBoolean("inventoryRead", true);
        }

        return false;
    }

    public boolean saveInventoryReadFileSync(boolean b) {
        return mSharedPrefs.edit().putBoolean("inventoryRead", b).commit();
    }


    public boolean getFixFileSync() {
        if (mSharedPrefs != null && mContext != null) {
            return mSharedPrefs.getBoolean("fix", true);
        }

        return false;
    }

    public boolean saveFixFileSync(boolean b) {
        return mSharedPrefs.edit().putBoolean("fix", b).commit();
    }
}
