package com.common.app.ui.adapter;

import android.content.Context;
import android.databinding.ViewDataBinding;
import android.view.LayoutInflater;

import com.common.app.R;
import com.common.app.base.BaseRecyclerAdapter;
import com.common.app.base.BaseViewHolder;

import java.util.List;

/**
 * Created by chenhongfei on 2017/4/27.
 */

public abstract class RAdapterFilter<D> extends BaseRecyclerAdapter<D> {
    protected int mSelectedPosition = -1;


    public RAdapterFilter(Context context, List<D> dataList) {
        this(context, dataList, R.layout.adapter_simple_list_item);
    }

    public RAdapterFilter(Context context, List<D> dataList, int layoutId) {
        mContext = context;
        mLayoutId = layoutId;
        mInflater = LayoutInflater.from(mContext);
        mDataList = dataList;
    }

    @Override
    public void onBindViewHolder(BaseViewHolder baseViewHolder, int position) {
        ViewDataBinding binding = baseViewHolder.getBinding();
        binding.setVariable(com.common.app.BR.isChosed, position == mSelectedPosition);
        binding.setVariable(com.common.app.BR.info, getFilterString(position));
        baseViewHolder.getBinding().executePendingBindings();
    }

    public void setSelectedPosition(int position) {
        mSelectedPosition = position;
        notifyDataSetChanged();
    }

    public int getSelectedPosition() {
        return mSelectedPosition;
    }

    public abstract String getFilterString(int position);
}
