package com.common.app.ui.util;

import android.app.Activity;
import android.app.Dialog;
import android.content.DialogInterface;
import android.databinding.DataBindingUtil;
import android.graphics.drawable.Drawable;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import com.common.app.R;
import com.common.app.databinding.LoadingDialogBinding;


/**
 * Created by guqingbo on 2016-08-03.
 */
public class LoadingDialogUtil {
    private final static String TAG = "LoadingDialogUtil";
    private static Dialog mdialog;

    public static void showLoadingDialog(Activity activity, int tipId) {
        String tip = activity.getString(tipId);
        showLoadingDialog(activity, tip);
    }

    public static void showLoadingDialog(Activity activity, int tipId, boolean canCancel) {
        String tip = activity.getString(tipId);
        showLoadingDialog(activity, tip, canCancel);
    }

    public static void showLoadingDialog(Activity activity, int tipId, DialogInterface.OnKeyListener onKeyListener) {
        String tip = activity.getString(tipId);
        showLoadingDialog(activity, tip, onKeyListener, true);
    }

    public static void showLoadingDialog(Activity activity, String tip) {
        showLoadingDialog(activity, tip, null, true);
    }

    public static void showLoadingDialog(Activity activity, String tip, boolean canCancel) {
        showLoadingDialog(activity, tip, null, canCancel);
    }

    public static void showLoadingDialog(Activity activity, String tip, DialogInterface.OnKeyListener onKeyListener, boolean canCancle) {
        closeLoadingDialog();
        LoadingDialogBinding binding = DataBindingUtil.inflate(LayoutInflater.from(activity),R.layout.loading_dialog,null,false);
        mdialog = new Dialog(activity, R.style.AppDialogTheme);
        mdialog.setContentView(binding.getRoot(), new ViewGroup.LayoutParams(activity
                .getWindowManager().getDefaultDisplay().getWidth() * 2 / 3,
                ViewGroup.LayoutParams.MATCH_PARENT));
        binding.tvLoadingText.setText(tip);
        if (android.os.Build.VERSION.SDK_INT > 22){
            Drawable drawable = ContextCompat.getDrawable(activity, R.drawable.loading_22);
            binding.progressBar.setIndeterminateDrawable(drawable);
        }

        mdialog.show();
        // 设置点击外围解散
        mdialog.setCanceledOnTouchOutside(canCancle);
    }
    /*
     * 关闭dialog
	 */

    public static void closeLoadingDialog() {
        if (mdialog != null) {
            mdialog.dismiss();
        }
    }
}
