package com.common.app.ui.util;

import android.app.Activity;

import java.util.HashSet;
import java.util.Set;

public class ManageActivity {
    private static ManageActivity instance;

    private Set<Activity> mSet = new HashSet<>();
//    private Set<Activity> mainSet = new HashSet<>();
    // 维护临时的activity，当最后一个页面关闭时，将这些临时activity都关闭。
    private Set<Activity> tmpSet = new HashSet<>();

    private ManageActivity() {

    }

    public synchronized static ManageActivity getInstance() {
        if (null == instance) {
            instance = new ManageActivity();
        }

        return instance;
    }

    public void addActivity(Activity activity) {
        mSet.add(activity);
    }

    public void removeActivity(Activity activity){
        mSet.remove(activity);
    }


    public void exit() {
        for (Activity activity : mSet) {
            if (activity != null) {
                activity.finish();
            }
        }
        mSet.clear();
    }

    public void addTmpActivity(Activity activity) {
        tmpSet.add(activity);
    }

    public void removeTmpActivity(Activity activity){
        tmpSet.remove(activity);
    }

    public void exitAllTmpActivity() {
        for (Activity activity : tmpSet) {
            if (activity != null) {
                activity.finish();
            }
        }
        tmpSet.clear();
    }

    public void exitAllActivity() {
//        mainExit();
        exit();
        exitAllTmpActivity();
    }
}
