package com.common.framework.network.parser;

import android.content.Context;
import android.content.Intent;
import android.text.TextUtils;

import com.common.app.R;
import com.common.app.base.BaseApplication;
import com.common.app.data.network.AppErrorCode;
import com.common.app.global.GlobalBroadcastActionName;
import com.common.framework.util.ToastUtil;

import java.io.Serializable;

public class ErrorInfo implements Serializable {

    public int code;
    public String msg;

    public int processErrorCode(Context context, String defaultMsg) {
        int res = 0;
        String code = "" + this.code;
        switch (code) {
            case AppErrorCode.EC_SINGLE_LOGIN:
                Intent intentLogin = new Intent();
                intentLogin.setAction(GlobalBroadcastActionName.USER_LOGIN_MULTI_TERMINAL);
                BaseApplication.getInstance().getLocalBroadcastManager().sendBroadcast(intentLogin);
                break;
            case AppErrorCode.EC_SESSION_INVALID:
                Intent intent = new Intent();
                intent.setAction(GlobalBroadcastActionName.USER_SESSION_INVALID);
                BaseApplication.getInstance().getLocalBroadcastManager().sendBroadcast(intent);
                break;


            default:
                if (TextUtils.isEmpty(this.msg)) {
                    ToastUtil.toast(defaultMsg);
                } else {
                    ToastUtil.toast(this.msg);
                }
                break;
        }


        return res;
    }

    public void processErrorCode(Context context) {
        processErrorCode(context, context.getResources().getString(R.string.commontips));
    }

//    public boolean checkServerError() {
//        boolean flag = false;
//        if (error != null && AppErrorCode.EC_NETWORK_ERROR.equals(error.code)) {
//            flag = true;
//        }
//
//        return flag;
//    }
}
