package com.common.framework.network.parser;

import android.os.Handler;
import android.os.Message;

import com.common.app.R;
import com.common.app.ui.util.LoadingDialogUtil;


/**
 * Created by guqingbo on 2016-07-12.
 */
public abstract class NetHandler<T extends ModelInfo> extends Handler {
    public NetHandler() {
        super();
    }

    @Override
    public void handleMessage(Message msg) {
        if (msg.what == R.id.doGetting) {
            onGetting();
        } else if (msg.what == R.id.doSuccess) {
            onSuccess(msg.arg1, (T) msg.obj);
        } else if (msg.what == R.id.doError) {
            onError(msg.arg1, ((T) msg.obj));
        } else if (msg.what == R.id.doDataError) {
            onDataError();
        } else if (msg.what == R.id.BadOnline) {
            onBadLine();
        }
    }

    public abstract void onGetting();

    public abstract void onError(int resId, ErrorInfo info);

    public abstract void onSuccess(int resId, T info);

    public void onDataError() {
        LoadingDialogUtil.closeLoadingDialog();
    }

    public void onBadLine() {
        LoadingDialogUtil.closeLoadingDialog();
    }

}



