package com.common.framework.network.parser;

import android.support.annotation.NonNull;

import com.common.framework.network.volley.HttpStatus;
import com.common.framework.util.AspLog;
import com.android.volley.Response;
import com.android.volley.VolleyError;

/**
 * Created by alexgu on 2017/2/19.
 */

public class ResponseListener<T extends ModelInfo> implements Response.Listener<T>, Response.ErrorListener {
    private BaseParser<T> mParser;
    private static final String TAG = "ResponseListener";

    public ResponseListener(@NonNull BaseParser<T> parser) {
        mParser = parser;
    }

    @Override
    public void onResponse(T response) {
        mParser.parseResponse(response);
    }

    @Override
    public void onErrorResponse(VolleyError error) {

        int statusCode = 0;
        try {
            AspLog.e(TAG, " json= error:" + error.getMessage());
            AspLog.e(TAG, " json= class:" + error.getClass().toString());
            AspLog.e(TAG, " json= getSuppressed:" + error.getSuppressed());
            AspLog.e(TAG, " json= getCause:" + error.getCause());
            AspLog.e(TAG, " json= getLocalizedMessage:" + error.getLocalizedMessage());
            AspLog.e(TAG, " json= networkResponse:" + error.networkResponse);
            error.printStackTrace();
            // 解析json出问题的话，抛出数据错误
            if (error.networkResponse == null) {
                // 解析json出问题的话，非网络问题
                if (error.getClass().toString().indexOf("ParseError") != -1) {
                    statusCode = HttpStatus.SC_OK;
                }
            } else {
                statusCode = error.networkResponse.statusCode;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        mParser.parseErrorResponse(statusCode);
    }
}
