package com.common.framework.util;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Intent;
import android.content.IntentFilter;

import com.common.app.base.BaseApplication;

/**
 * Created by chenhongfei on 2016/9/22.
 */
public class BroadcastReceiverUtil {
    private static final String TAG = "BroadcastReceiverUtil";

    public static void registerBroadcastReceiver(Activity activity, BroadcastReceiver broadcastReceiver, String actionName) {
        AspLog.d(TAG, String.format("registerBroadcastReceiver: actionName:%s, activity:%s===", actionName, activity));
        IntentFilter filter = new IntentFilter();
        filter.addAction(actionName);

        activity.registerReceiver(broadcastReceiver, filter);
    }

    public static void unRegisterBroadcastReceiver(Activity activity, BroadcastReceiver broadcastReceiver) {
        AspLog.d(TAG, String.format("unRegisterBroadcastReceiver: activity:%s===", activity));
        activity.unregisterReceiver(broadcastReceiver);
    }

    public static void registerLocalBroadcastReceiver(BroadcastReceiver broadcastReceiver, String actionName) {
        AspLog.d(TAG, String.format("registerLocalBroadcastReceiver: actionName:%s, ===", actionName));
        IntentFilter filter = new IntentFilter();
        filter.addAction(actionName);

        BaseApplication.getInstance().getLocalBroadcastManager().registerReceiver(broadcastReceiver, filter);
    }

    public static void unRegisterLocalBroadcastReceiver(BroadcastReceiver broadcastReceiver) {
        AspLog.d(TAG, "unRegisterLocalBroadcastReceiver: ===");
        BaseApplication.getInstance().getLocalBroadcastManager().unregisterReceiver(broadcastReceiver);
    }

    public static void sendLocalBroadcast(Intent intent) {
        BaseApplication.getInstance().getLocalBroadcastManager().sendBroadcast(intent);
    }
}
