//package com.alex.common.view.customview;
//
//import android.content.Context;
//import android.content.res.TypedArray;
//import android.graphics.drawable.Drawable;
//import android.support.annotation.Nullable;
//import android.text.Editable;
//import android.text.TextUtils;
//import android.text.TextWatcher;
//import android.util.AttributeSet;
//import android.widget.Button;
//import android.widget.EditText;
//
//import com.yasoon.acc369common.R;
//import com.yasoon.framework.util.StringUtil;
//
//import java.util.HashMap;
//import java.util.Map;
//import java.util.Set;
//
///**
// * Created by guqingbo on 2016-08-11.
// */
//public class ConditionButton extends Button {
//    private Drawable enableDrawable;
//    private Drawable unableDrawable;
//
//    public enum MODE {NAME, PASSWORD, NOT_EMPTY, PHONE}
//
//    private Map<EditText, MODE> editTextMap = new HashMap<>();
//
//    public ConditionButton(Context context) {
//        this(context, null);
//    }
//
//    public ConditionButton(Context context, AttributeSet attrs) {
//        this(context, attrs, android.R.attr.buttonStyle);
//    }
//
//    public ConditionButton(Context context, AttributeSet attrs, int defStyleAttr) {
//        super(context, attrs, defStyleAttr);
//
//        init(attrs);
//    }
//
//    private void init(AttributeSet attrs) {
//        if (attrs != null) {
//            TypedArray typedArray = getContext().obtainStyledAttributes(attrs, R.styleable.ConditionButton);
//            if (typedArray != null) {
//                enableDrawable = typedArray.getDrawable(R.styleable.ConditionButton_enableDraw);
//                unableDrawable = typedArray.getDrawable(R.styleable.ConditionButton_unableDraw);
//                typedArray.recycle();
//            }
//
//            if (enableDrawable == null) {
//                enableDrawable = getBackground();
//            }
//
//            if (unableDrawable == null) {
//                unableDrawable = getBackground();
//            }
//        }
//    }
//
//    public void setEditCheck(@Nullable EditText editText, @Nullable MODE mode) {
//        editTextMap.put(editText, mode);
//        MyTextWatcher myTextWatcher = new MyTextWatcher();
//        editText.addTextChangedListener(myTextWatcher);
//        editTextChanged();
//    }
//
//    private void editTextChanged() {
//        if (judge()) {
//            setBackgroundDrawable(enableDrawable);
//            setEnabled(true);
//        } else {
//            setBackgroundDrawable(unableDrawable);
//            setEnabled(false);
//        }
//    }
//
//    private boolean judge() {
//        Set<Map.Entry<EditText, MODE>> set = editTextMap.entrySet();
//        for (Map.Entry<EditText, MODE> entry : set) {
//            EditText editText = entry.getKey();
//            MODE mode = entry.getValue();
//            String content = editText.getText().toString();
//            switch (mode) {
//                case NAME:
//                    if (!nameCheck.check(content)) {
//                        return false;
//                    }
//                    break;
//                case PASSWORD:
//                    if (!pwdCheck.check(content)) {
//                        return false;
//                    }
//                    break;
//                case NOT_EMPTY:
//                    if (!notEmptyCheck.check(content)){
//                        return false;
//                    }
//                    break;
//                case PHONE:
//                    if (!phoneCheck.check(content)) {
//                        return false;
//                    }
//                    break;
//            }
//        }
//        return true;
//    }
//
//    //当EditText为name的时候的判断方式
//    private ICheck nameCheck = new ICheck() {
//        @Override
//        public Boolean check(CharSequence content) {
//            String strText = content.toString().trim();
//            if (!TextUtils.isEmpty(strText)) {
////                if (Validate.isMobileNO(strText) || Validate.IsEmail(strText))
//                    return true;
//            }
//            return false;
//        }
//    };
//
//    //当EditText为passWd的时候的判断方式
//    private ICheck pwdCheck = new ICheck() {
//        @Override
//        public Boolean check(CharSequence content) {
//            String strText = content.toString().trim();
//            if (!TextUtils.isEmpty(strText))
//                return true;
//            return false;
//        }
//    };
//
//    private ICheck phoneCheck = new ICheck() {
//        @Override
//        public Boolean check(CharSequence content) {
//            String strText = content.toString().trim();
//            return (!TextUtils.isEmpty(strText) && StringUtil.isMobile(strText));
//        }
//    };
//
//    private ICheck notEmptyCheck = new ICheck() {
//        @Override
//        public Boolean check(CharSequence content) {
//            return !TextUtils.isEmpty(content);
//        }
//    };
//
//    //自定义的TextWatcher类，主要用来保存对应的itemStruct
//    private class MyTextWatcher implements TextWatcher {
//
//        public MyTextWatcher() {
//
//        }
//
//        @Override
//        public void beforeTextChanged(CharSequence s, int start, int count, int after) {
//        }
//
//        @Override
//        public void onTextChanged(CharSequence s, int start, int before, int count) {
//            editTextChanged();
//        }
//
//        @Override
//        public void afterTextChanged(Editable s) {
//        }
//    }
//
//    //接口
//    public interface ICheck {
//        Boolean check(CharSequence content);
//    }
//
//}