package com.common.framework.view.customview;

import android.content.Context;
import android.util.AttributeSet;

/**
 * Created by guqingbo on 2016-08-12.
 */
public class FilterEmojiEditText extends FilterEditText {
    public FilterEmojiEditText(Context context) {
        this(context, null);
    }

    public FilterEmojiEditText(Context context, AttributeSet attrs) {
        //这里构造方法也很重要，不加这个很多属性不能再XML里面定义
        this(context, attrs, android.R.attr.editTextStyle);
    }

    public FilterEmojiEditText(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
    }

    @Override
    protected void init(AttributeSet attrs) {
        super.init(attrs);
        addFilter(new JugeEmoji());
    }

    class JugeEmoji implements IJugeFilter {

        @Override
        public Boolean jugeFilter(char oneChar) {
            return (oneChar == 0x0) ||
                    (oneChar == 0x9) ||
                    (oneChar == 0xA) ||
                    (oneChar == 0xD) ||
                    ((oneChar >= 0x20) && (oneChar <= 0xD7FF)) ||
                    ((oneChar >= 0xE000) && (oneChar <= 0xFFFD)) ||
                    ((oneChar >= 0x10000) && (oneChar <= 0x10FFFF));
        }
    }
}
