//package com.alex.common.view.customview;
//
//import android.content.Context;
//import android.content.res.TypedArray;
//import android.graphics.drawable.Drawable;
//import android.util.AttributeSet;
//import android.view.MotionEvent;
//import android.view.inputmethod.EditorInfo;
//
//import com.yasoon.acc369common.R;
//
///**
// * Created by guqingbo on 2016-08-10.
// */
//public class PasswordEditText extends FilterEmojiEditText {
//    private Drawable showDrawble;
//    private Drawable hideDrawble;
//
//    public PasswordEditText(Context context) {
//        this(context, null);
//    }
//
//    public PasswordEditText(Context context, AttributeSet attrs) {
//        //这里构造方法也很重要，不加这个很多属性不能再XML里面定义
//        this(context, attrs, android.R.attr.editTextStyle);
//    }
//
//    public PasswordEditText(Context context, AttributeSet attrs, int defStyle) {
//        super(context, attrs, defStyle);
//        init(attrs);
//    }
//
//    @Override
//    protected void init(AttributeSet attrs) {
//        super.init(attrs);
//        addFilter(new JugePassword());
//        if (attrs != null) {
//            TypedArray typedArray = getContext().obtainStyledAttributes(attrs, R.styleable.PasswordEditText);
//            if (typedArray != null){
//                showDrawble = typedArray.getDrawable(R.styleable.PasswordEditText_show);
//                hideDrawble = typedArray.getDrawable(R.styleable.PasswordEditText_hide);
//                typedArray.recycle();
//            }
//            if(showDrawble == null){
//                showDrawble = getResources().getDrawable(R.drawable.icon_password_show);
//            }
//
//            if(hideDrawble == null){
//                hideDrawble = getResources().getDrawable(R.drawable.icon_password_hide);
//            }
//            showDrawble.setBounds(0, 0, showDrawble.getIntrinsicWidth(), showDrawble.getIntrinsicHeight());
//            hideDrawble.setBounds(0, 0, hideDrawble.getIntrinsicWidth(), hideDrawble.getIntrinsicHeight());
//
//        }
//
//        setPasswordVisible(isPasswordVisible());
//    }
//
//
//    //不能直接设置drawble的点击事件，计算drawble的水平位置来模拟
//    @Override
//    public boolean onTouchEvent(MotionEvent event) {
//        if (event.getAction() == MotionEvent.ACTION_UP) {
//            if (getCompoundDrawables()[2] != null) {
//
//                boolean touchable = event.getX() > (getWidth() - getTotalPaddingRight())
//                        && (event.getX() < ((getWidth() - getPaddingRight())));
//
//                if (touchable) {
//                    switchPasswordVisible();
//                }
//            }
//        }
//
//        return super.onTouchEvent(event);
//    }
//
//    private void switchPasswordVisible(){
//        setPasswordVisible(!isPasswordVisible());
//    }
//
//    private boolean isPasswordVisible(){
//        int inputType = getInputType();
//        final int variation = inputType & (EditorInfo.TYPE_MASK_CLASS | EditorInfo.TYPE_MASK_VARIATION);
//        return (variation == (EditorInfo.TYPE_CLASS_TEXT | EditorInfo.TYPE_TEXT_VARIATION_VISIBLE_PASSWORD));
//    }
//
//    public void setPasswordVisible(boolean isVisible){
//        Drawable right;
//        if (isVisible) {
//            setInputType(EditorInfo.TYPE_CLASS_TEXT | EditorInfo.TYPE_TEXT_VARIATION_VISIBLE_PASSWORD);
//            right = showDrawble;
//        } else {
//            setInputType(EditorInfo.TYPE_CLASS_TEXT | EditorInfo.TYPE_TEXT_VARIATION_PASSWORD);
//            right = hideDrawble;
//        }
//
//        setCompoundDrawables(getCompoundDrawables()[0],
//                getCompoundDrawables()[1], right, getCompoundDrawables()[3]);
//    }
//
//
//    //密码模式去掉中文，空格等符号，只允许英文符号
//    class JugePassword implements IJugeFilter{
//
//        @Override
//        public Boolean jugeFilter(char oneChar) {
//            return !(oneChar >= 0x007f || oneChar == 0x0020);
//        }
//    }
//}
