/*
 * 	   Created by Daniel Nadeau
 * 	   daniel.nadeau01@gmail.com
 * 	   danielnadeau.blogspot.com
 * 
 * 	   Licensed to the Apache Software Foundation (ASF) under one
       or more contributor license agreements.  See the NOTICE file
       distributed with this work for additional information
       regarding copyright ownership.  The ASF licenses this file
       to you under the Apache License, Version 2.0 (the
       "License"); you may not use this file except in compliance
       with the License.  You may obtain a copy of the License at

         http://www.apache.org/licenses/LICENSE-2.0

       Unless required by applicable law or agreed to in writing,
       software distributed under the License is distributed on an
       "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
       KIND, either express or implied.  See the License for the
       specific language governing permissions and limitations
       under the License.
 */

package com.common.framework.view.customview.bargraph;

import android.graphics.Path;
import android.graphics.Region;

import java.util.ArrayList;

public class Bar {

	public int currentValue = 0;
    private int color;
	private String name;
	private int maxvalue;
	private int value;
	private Path path;
	private Region region;
    private boolean isStackedBar;
    private ArrayList<BarStackSegment> values = new ArrayList<BarStackSegment>();
	
	public int getColor() {
		return color;
	}
	public void setColor(int color) {
		this.color = color;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public int getValue() {
		return value;
	}
	public void setValue(int value) {
		this.value = value;
	}
	public Path getPath() {
		return path;
	}
	public void setPath(Path path) {
		this.path = path;
	}
	public Region getRegion() {
		return region;
	}
	public void setRegion(Region region) {
		this.region = region;
	}
    public void setStackedBar(boolean stacked){
        isStackedBar = stacked;
    }
    public boolean getStackedBar(){
        return isStackedBar;
    }
    public void AddStackValue(BarStackSegment val){
        values.add(val);
    }
    public ArrayList<BarStackSegment> getStackedValues(){
        return values;
    }
	public float getMaxvalue() {
		return maxvalue;
	}
    
    
	
}
