///*
// * 	   Created by Daniel Nadeau
// * 	   daniel.nadeau01@gmail.com
// * 	   danielnadeau.blogspot.com
// *
// * 	   Licensed to the Apache Software Foundation (ASF) under one
//       or more contributor license agreements.  See the NOTICE file
//       distributed with this work for additional information
//       regarding copyright ownership.  The ASF licenses this file
//       to you under the Apache License, Version 2.0 (the
//       "License"); you may not use this file except in compliance
//       with the License.  You may obtain a copy of the License at
//
//         http://www.apache.org/licenses/LICENSE-2.0
//
//       Unless required by applicable law or agreed to in writing,
//       software distributed under the License is distributed on an
//       "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
//       KIND, either express or implied.  See the License for the
//       specific language governing permissions and limitations
//       under the License.
// */
//
//package com.alex.common.view.customview.bargraph;
//
//import android.content.Context;
//import android.graphics.Bitmap;
//import android.graphics.Bitmap.Config;
//import android.graphics.Canvas;
//import android.graphics.Color;
//import android.graphics.Paint;
//import android.graphics.Path;
//import android.graphics.Point;
//import android.graphics.Rect;
//import android.graphics.RectF;
//import android.graphics.Region;
//import android.graphics.drawable.NinePatchDrawable;
//import android.util.AttributeSet;
//import android.view.MotionEvent;
//import android.view.View;
//import android.view.ViewTreeObserver.OnPreDrawListener;
//import java.util.ArrayList;
//
//
//public class BarGraph extends View {
//
//    private ArrayList<Bar> points = new ArrayList<Bar>();
//    private Paint p = new Paint();
//    private Path path = new Path();
//    private Rect r;
//    private boolean showBarText = true;
//    private int indexSelected = -1;
//    private OnBarClickedListener listener;
//    private Bitmap fullImage;
//    private boolean shouldUpdate = false;
//    private String unit = "$";
//    private Boolean append = false;
//    private Rect r2 = new Rect();
//    private Rect r3 = new Rect();
//    private float currentValue1 = 0;
//    private float currentValue2 = 0;
//    private Canvas canvas;
//
//    public BarGraph(Context context) {
//        super(context);
//    }
//
//    public BarGraph(Context context, AttributeSet attrs) {
//        super(context, attrs);
//    }
//
//    public void setShowBarText(boolean show) {
//        showBarText = show;
//    }
//
//    public void setBars(ArrayList<Bar> points) {
//        this.points = points;
//        this.getViewTreeObserver().addOnPreDrawListener(
//                new OnPreDrawListener() {
//                    public boolean onPreDraw() {
//                        new thread();
//                        getViewTreeObserver().removeOnPreDrawListener(this);
//                        return false;
//                    }
//                });
//    }
//
//    class thread implements Runnable {
//        private Thread thread;
//        private int statek;
//        int count;
//
//        public thread() {
//            thread = new Thread(this);
//            thread.start();
//        }
//
//        public void run() {
//            while (true) {
//
//                switch (statek) {
//                    case 0:
//                        try {
//                            Thread.sleep(200);
//                            statek = 1;
//                        } catch (InterruptedException e) {
//                        }
//                        break;
//                    case 1:
//                        try {
//                            Thread.sleep(20);
//                            count++;
//                            postInvalidate();  //在工作线程来调用，刷新View
//                        } catch (InterruptedException e) {
//                            e.printStackTrace();
//                        }
//                        break;
//                }
//                if (count >= 200)
//                    break;
//            }
//        }
//    }
//
//    public void setUnit(String unit) {
//        this.unit = unit;
//    }
//
//    public String getUnit() {
//        return this.unit;
//    }
//
//    public void appendUnit(Boolean doAppend) {
//        this.append = doAppend;
//    }
//
//    public Boolean isAppended() {
//        return this.append;
//    }
//
//    public ArrayList<Bar> getBars() {
//        return this.points;
//    }
//
//    public void onDraw(Canvas ca) {
//
//        canvas = ca;
//
//        if (true) {
//            fullImage = Bitmap.createBitmap(getWidth(), getHeight(), Config.ARGB_8888);
//            Canvas canvas = new Canvas(fullImage);
//            canvas.drawColor(Color.TRANSPARENT);
//            NinePatchDrawable popup = (NinePatchDrawable) this.getResources().getDrawable(R.drawable.ic_null);
//
//            float maxValue = 0;
//            float padding = 20;
//            int selectPadding = 4;
//            float bottomPadding = 40;
//
//            float usableHeight;
//            if (showBarText) {
//                this.p.setTextSize(40);
//                this.p.getTextBounds(unit, 0, 1, r3);
//                usableHeight = getHeight() - bottomPadding - Math.abs(r3.top - r3.bottom) - 26;
//            } else {
//                usableHeight = getHeight() - bottomPadding;
//            }
//
//
//            p.setColor(Color.BLACK);
//            p.setStrokeWidth(2);
//            p.setAlpha(50);
//            p.setAntiAlias(true);
//            p.setTextSize(30);
//            int segment = (int) (usableHeight / 4);
//            canvas.drawLine(70, getHeight() - bottomPadding + 10 - segment, getWidth() - 20, getHeight() - bottomPadding + 10 - segment, p);
//            canvas.drawLine(70, getHeight() - bottomPadding + 10 - segment * 2, getWidth() - 20, getHeight() - bottomPadding + 10 - segment * 2, p);
//            canvas.drawLine(70, getHeight() - bottomPadding + 10 - segment * 3, getWidth() - 20, getHeight() - bottomPadding + 10 - segment * 3, p);
//            canvas.drawLine(70, getHeight() - bottomPadding + 10 - segment * 4, getWidth() - 20, getHeight() - bottomPadding + 10 - segment * 4, p);
//            drawAL(70, (int) (getHeight() - bottomPadding + 10), 70, (int) (getHeight() - bottomPadding + 30 - segment * 5), p);
//            drawAL(70, (int) (getHeight() - bottomPadding + 10), getWidth() - 20, (int) (getHeight() - bottomPadding + 10), p);
////            canvas.drawLine(70, getHeight() - bottomPadding + 10, getWidth(), getHeight() - bottomPadding + 10, p);
//            float barWidth = (getWidth() - (padding * 2) * points.size()) / points.size();
//
//            for (Bar p : points) {
//                maxValue += p.getValue();
//            }
//            int seg = (int) (maxValue / 4);
//            canvas.drawText("0", 20, getHeight() - bottomPadding + 10, p);
//            for (int i = 1; i < 4; i++) {
//                if (seg == 0) {
//                    canvas.drawText("", 10, getHeight() - bottomPadding + 10 - segment * i, this.p);
//                } else {
//                    canvas.drawText("" + (seg * i), 10, getHeight() - bottomPadding + 10 - segment * i, this.p);
//                }
//
//            }
//            canvas.drawText("" + (int) maxValue, 10, getHeight() - bottomPadding + 10 - segment * 4, this.p);
//            canvas.drawText("人数", 10, getHeight() - bottomPadding + 10 - segment * 4 - 40, this.p);
//
//            r = new Rect();
//
//            path.reset();
//
//            int count = 0;
//            for (Bar p : points) {
//                if (p.currentValue < p.getValue()) {
//                    p.currentValue += 2;
//                    if (p.currentValue > p.getValue()) {
//                        p.currentValue = p.getValue();
//                    }
//                }
//
//                r.set((int) ((padding * 2) * count + padding + barWidth * count), (int) (getHeight() - 30 - (usableHeight * (p.currentValue / maxValue))), (int) ((padding * 2) * count + padding + barWidth * (count + 1)), (int) (getHeight() - 30));
//                path.addRect(new RectF(r.left - selectPadding, r.top - selectPadding, r.right + selectPadding, r.bottom + selectPadding), Path.Direction.CW);
//                p.setPath(path);
//                p.setRegion(new Region(r.left - selectPadding, r.top - selectPadding, r.right + selectPadding, r.bottom + selectPadding));
//                this.p.setColor(p.getColor());
//                this.p.setAlpha(255);
//                canvas.drawRect(r, this.p);
//
//                this.p.setTextSize(20);
//                canvas.drawText(p.getName(), (int) (((r.left + r.right) / 2) - (this.p.measureText(p.getName()) / 2)), getHeight() - 5, this.p);
//                if (showBarText) {
//                    this.p.setTextSize(40);
//                    this.p.setColor(p.getColor());
//                    this.p.getTextBounds(unit + p.getValue(), 0, 1, r2);
//                    if (popup != null)
//                        popup.setBounds((int) (((r.left + r.right) / 2) - (this.p.measureText(unit + p.getValue()) / 2)) - 14, r.top + (r2.top - r2.bottom) - 26, (int) (((r.left + r.right) / 2) + (this.p.measureText(unit + p.getValue()) / 2)) + 14, r.top);
//                    popup.draw(canvas);
//                    if (p.getValue() != 0) {
//                        if (isAppended())
//                            canvas.drawText(p.currentValue + unit, (int) (((r.left + r.right) / 2) - (this.p.measureText(unit + p.getValue()) / 2)), r.top - 20, this.p);
//                        else
//                            canvas.drawText(unit + p.currentValue, (int) (((r.left + r.right) / 2) - (this.p.measureText(unit + p.getValue()) / 2)), r.top - 20, this.p);
//                    }
//
//                }
//                if (indexSelected == count && listener != null) {
//                    this.p.setColor(Color.parseColor("#33B5E5"));
//                    this.p.setAlpha(100);
//                    canvas.drawPath(p.getPath(), this.p);
//                    this.p.setAlpha(255);
//                }
//
//                count++;
//            }
////            shouldUpdate = false;
//        }
//
//        ca.drawBitmap(fullImage, 0, 0, null);
//
//    }
//
//    @Override
//    public boolean onTouchEvent(MotionEvent event) {
//
//        Point point = new Point();
//        point.x = (int) event.getX();
//        point.y = (int) event.getY();
//
//        int count = 0;
//        for (Bar bar : points) {
//            Region r = new Region();
//            r.setPath(bar.getPath(), bar.getRegion());
//            if (r.contains(point.x, point.y) && event.getAction() == MotionEvent.ACTION_DOWN) {
//                indexSelected = count;
//            } else if (event.getAction() == MotionEvent.ACTION_UP) {
//                if (r.contains(point.x, point.y) && listener != null) {
//                    listener.onClick(indexSelected);
//                }
//                indexSelected = -1;
//            }
//            count++;
//        }
//
//        if (event.getAction() == MotionEvent.ACTION_DOWN || event.getAction() == MotionEvent.ACTION_UP) {
//            shouldUpdate = true;
//            postInvalidate();
//        }
//
//
//        return true;
//    }
//
//    public void setOnBarClickedListener(OnBarClickedListener listener) {
//        this.listener = listener;
//    }
//
//    public interface OnBarClickedListener {
//        abstract void onClick(int index);
//    }
//
//
//    /**
//     * 画箭头
//     *
//     * @param sx
//     * @param sy
//     * @param ex
//     * @param ey
//     */
//    public void drawAL(int sx, int sy, int ex, int ey, Paint p) {
//        double H = 8; // 箭头高度
//        double L = 3.5; // 底边的一半
//        int x3 = 0;
//        int y3 = 0;
//        int x4 = 0;
//        int y4 = 0;
//        double awrad = Math.atan(L / H); // 箭头角度
//        double arraow_len = Math.sqrt(L * L + H * H); // 箭头的长度
//        double[] arrXY_1 = rotateVec(ex - sx, ey - sy, awrad, true, arraow_len);
//        double[] arrXY_2 = rotateVec(ex - sx, ey - sy, -awrad, true, arraow_len);
//        double x_3 = ex - arrXY_1[0]; // (x3,y3)是第一端点
//        double y_3 = ey - arrXY_1[1];
//        double x_4 = ex - arrXY_2[0]; // (x4,y4)是第二端点
//        double y_4 = ey - arrXY_2[1];
//        Double X3 = new Double(x_3);
//        x3 = X3.intValue();
//        Double Y3 = new Double(y_3);
//        y3 = Y3.intValue();
//        Double X4 = new Double(x_4);
//        x4 = X4.intValue();
//        Double Y4 = new Double(y_4);
//        y4 = Y4.intValue();
//        // 画线
//        canvas.drawLine(sx, sy, ex, ey, p);
//        Path triangle = new Path();
//        triangle.moveTo(ex, ey);
//        triangle.lineTo(x3, y3);
//        triangle.lineTo(x4, y4);
//        triangle.close();
//        canvas.drawPath(triangle, p);
//
//    }
//
//    // 计算
//    public double[] rotateVec(int px, int py, double ang, boolean isChLen, double newLen) {
//        double mathstr[] = new double[2];
//        // 矢量旋转函数，参数含义分别是x分量、y分量、旋转角、是否改变长度、新长度
//        double vx = px * Math.cos(ang) - py * Math.sin(ang);
//        double vy = px * Math.sin(ang) + py * Math.cos(ang);
//        if (isChLen) {
//            double d = Math.sqrt(vx * vx + vy * vy);
//            vx = vx / d * newLen;
//            vy = vy / d * newLen;
//            mathstr[0] = vx;
//            mathstr[1] = vy;
//        }
//        return mathstr;
//    }
//
//
//}
